/*+
|                                               |
|     Trigger: DTULTATU_MODODIVULG              |  
|     Tabela : MODODIVULG                       |
|                                               |
|     Criao:                                  |
|     23/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_MODODIVULG
BEFORE INSERT OR UPDATE OR DELETE
ON MODODIVULG FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMDIV := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF ((NVL(:OLD.CDMODODIVULG,   0) <> NVL(:NEW.CDMODODIVULG,  0)) OR
           (NVL(:OLD.NMMODODIVULG,  0) <> NVL(:NEW.NMMODODIVULG,  0))) THEN
           :NEW.DTULTATUMDIV := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
      VALUES ('MODODIVULG'  , '', 'CDMODODIVULG='||:OLD.CDMODODIVULG||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MODODIVULG MODIFY DTULTATUMDIV DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MODODIVULG','4.11.160'); END;
/

