/* Exclui as dados gerados da movimentao do caixa para o financeiro*/

CREATE OR REPLACE PROCEDURE CANCELA_EXPORTA_PDV_FINANC(
   P_CDFILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,       /*CDFILIALNF da MOVCAIXA*/
   P_NRLANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE)     /*NRLANCTONF da MOVCAIXA*/
AS
   V_CDEMPRESA    CONTARECEBER.CDEMPRESA%TYPE;
   V_CDFIMOVFLREC CONTARECEBER.CDFIMOVFLREC%TYPE;
   V_DTATUAVENREC CONTARECEBER.DTATUAVENREC%TYPE;
   V_IDMOVFLUXO   CONTARECEBER.IDMOVFLUXO%TYPE;
   V_CDCLASSFINA  CONTARECEBER.CDCLASSFINA%TYPE;
   V_VRORIGREC    CONTARECEBER.VRORIGREC%TYPE;
   V_VRAJUSTE     AJCTPAGAR.VRAJUSTEPAG%TYPE;
   V_IDAJUCTREC   TIPOAJRECEBER.IDAJUCTREC%TYPE;

   V_NRCHEQUEVEND MOVCAIXA.NRCHEQUEVEND%TYPE;
   V_CDBANCHEQVEN MOVCAIXA.CDBANCHEQVEN%TYPE;
   V_CDAGECHEQVEN MOVCAIXA.CDAGECHEQVEN%TYPE;
   V_CDCNTCHEQVEN MOVCAIXA.CDCNTCHEQVEN%TYPE;

   V_NRLANCTBDOC  NOTAFISCAL.NRLANCTBDOC%TYPE;
BEGIN

   /*Deleta os ajustes da conta*/
   FOR C_AJUSTECNT IN(
   SELECT A.CDFILIAL,    A.NRLANCTONF,   A.NRSEQVENREC,  A.NRPARCELAREC,
          A.DTAJUSTEREC, A.CDAJUCTREC,   T.IDAJUCTREC,   A.VRAJUSTEREC,
          A.CDCLASSFINA, A.CDEMMFAJCNTR, A.CDFIMFAJCNTR, A.DTMOVFLUXO,
          A.IDMOVFLUXO,  A.CDECTBAJREC,  A.NRLCTBAJREC
     FROM AJCTRECEBER A, TIPOAJRECEBER T
    WHERE (A.CDFILIAL   = P_CDFILIAL)
      AND (A.NRLANCTONF = P_NRLANCTONF)
      AND (A.CDAJUCTREC =  T.CDAJUCTREC)) LOOP

      IF C_AJUSTECNT.IDAJUCTREC = 'A' THEN
         ATUALIZA_FLUXO_DE_CAIXA(C_AJUSTECNT.CDEMMFAJCNTR,
                                 C_AJUSTECNT.CDFIMFAJCNTR,
                                 C_AJUSTECNT.DTMOVFLUXO,
                                 C_AJUSTECNT.IDMOVFLUXO,
                                 C_AJUSTECNT.CDCLASSFINA,
                                 C_AJUSTECNT.VRAJUSTEREC * -1,
                                 0);
      ELSE
         ATUALIZA_FLUXO_DE_CAIXA(C_AJUSTECNT.CDEMMFAJCNTR,
                                 C_AJUSTECNT.CDFIMFAJCNTR,
                                 C_AJUSTECNT.DTMOVFLUXO,
                                 C_AJUSTECNT.IDMOVFLUXO,
                                 C_AJUSTECNT.CDCLASSFINA,
                                 C_AJUSTECNT.VRAJUSTEREC,
                                 0);
      END IF;

      DELETE FROM LANCCONT
       WHERE CDEMPRESA  = C_AJUSTECNT.CDECTBAJREC
         AND NRLANCCONT = C_AJUSTECNT.NRLCTBAJREC;

      DELETE FROM AJCTRECEBER
       WHERE CDFILIAL     = P_CDFILIAL
         AND NRLANCTONF   = P_NRLANCTONF
         AND NRSEQVENREC  = C_AJUSTECNT.NRSEQVENREC
         AND NRPARCELAREC = C_AJUSTECNT.NRPARCELAREC
         AND DTAJUSTEREC  = C_AJUSTECNT.DTAJUSTEREC
         AND CDAJUCTREC   = C_AJUSTECNT.CDAJUCTREC;
   END LOOP;

   /*Deleta o rateio*/
   DELETE FROM RATCTRECEBER
    WHERE CDFILIAL   = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   SELECT MAX(CDEMPRESA), MAX(CDFIMOVFLREC), MAX(DTATUAVENREC),
          MAX(IDMOVFLUXO), MAX(CDCLASSFINA), MAX(VRORIGREC)
     INTO V_CDEMPRESA, V_CDFIMOVFLREC, V_DTATUAVENREC,
          V_IDMOVFLUXO, V_CDCLASSFINA, V_VRORIGREC
     FROM CONTARECEBER
    WHERE CDFILIAL   = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   ATUALIZA_FLUXO_DE_CAIXA(V_CDEMPRESA,
                           V_CDFIMOVFLREC,
                           V_DTATUAVENREC,
                           V_IDMOVFLUXO,
                           V_CDCLASSFINA,
                           V_VRORIGREC * -1,
                           0);

   /*Deleta o boleto, a conta e os ajustes do boleto*/
   FOR C_BOLETOS IN(
   SELECT CDFILIBOLREC, NRLANBOLREC, CDFILIAL, NRSEQVENREC, NRPARCELAREC,
          CDEMPRESA, CDFIMOVFLREC, CDCLASSFINA, DTMOVFLUXO, IDMOVFLUXO
     FROM CONTARECEBER
    WHERE (CDFILIAL   = P_CDFILIAL)
      AND (NRLANCTONF = P_NRLANCTONF)) LOOP

      FOR C_AJUSTEBOL IN(
         SELECT CDFILIAL, NRLANBOLREC, CDAJUCTREC, VRAJBOLREC
           FROM AJBOLREC
          WHERE (CDFILIAL    = C_BOLETOS.CDFILIBOLREC)
            AND (NRLANBOLREC = C_BOLETOS.NRLANBOLREC)) LOOP

         SELECT MAX(IDAJUCTREC)
           INTO V_IDAJUCTREC
           FROM TIPOAJRECEBER
          WHERE CDAJUCTREC = C_AJUSTEBOL.CDAJUCTREC;

         IF V_IDAJUCTREC = 'D' THEN
            V_VRAJUSTE := C_AJUSTEBOL.VRAJBOLREC;
         ELSE
            V_VRAJUSTE := C_AJUSTEBOL.VRAJBOLREC * -1;
         END IF;

         ATUALIZA_FLUXO_DE_CAIXA(C_BOLETOS.CDEMPRESA,
                                 C_BOLETOS.CDFIMOVFLREC,
                                 C_BOLETOS.DTMOVFLUXO,
                                 C_BOLETOS.IDMOVFLUXO,
                                 C_BOLETOS.CDCLASSFINA,
                                 V_VRAJUSTE,
                                 0);

         DELETE FROM MOVFXAJBOLR
          WHERE CDEMPRESA    = C_BOLETOS.CDEMPRESA
            AND CDFILIAL     = C_AJUSTEBOL.CDFILIAL
            AND CDCLASSFINA  = C_BOLETOS.CDCLASSFINA
            AND DTMOVFLUXO   = C_BOLETOS.DTMOVFLUXO
            AND IDMOVFLUXO   = C_BOLETOS.IDMOVFLUXO
            AND CDFILIBOLREC = C_BOLETOS.CDFIMOVFLREC
            AND NRLANBOLREC  = C_AJUSTEBOL.NRLANBOLREC
            AND CDAJUCTREC   = C_AJUSTEBOL.CDAJUCTREC;

         DELETE FROM AJBOLREC
          WHERE (CDFILIAL    = C_AJUSTEBOL.CDFILIAL   )
            AND (NRLANBOLREC = C_AJUSTEBOL.NRLANBOLREC)
            AND (CDAJUCTREC  = C_AJUSTEBOL.CDAJUCTREC);
      END LOOP;

      /*Exclui a conta*/
      DELETE FROM CONTARECEBER
       WHERE CDFILIAL     = P_CDFILIAL
         AND NRLANCTONF   = P_NRLANCTONF
         AND NRSEQVENREC  = C_BOLETOS.NRSEQVENREC
         AND NRPARCELAREC = C_BOLETOS.NRPARCELAREC;

      /*Exclui o boleto*/
      DELETE FROM BOLETRECEBER
       WHERE CDFILIAL    = C_BOLETOS.CDFILIBOLREC
         AND NRLANBOLREC = C_BOLETOS.NRLANBOLREC;
   END LOOP;

   SELECT MAX(NRCHEQUEVEND), MAX(CDBANCHEQVEN),
          MAX(CDAGECHEQVEN), MAX(CDCNTCHEQVEN)
     INTO V_NRCHEQUEVEND, V_CDBANCHEQVEN,
          V_CDAGECHEQVEN, V_CDCNTCHEQVEN
     FROM MOVCAIXA
    WHERE CDFILIALNF = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   /*Exclui os cheques recebidos*/
   IF V_NRCHEQUEVEND IS NOT NULL THEN
      DELETE FROM CHEQUERECE
       WHERE NRCHEQUERECE = V_NRCHEQUEVEND
         AND CDBANCHEQREC = V_CDBANCHEQVEN
         AND CDAGECHEQREC = V_CDAGECHEQVEN
         AND CDCNTCHEQREC = V_CDCNTCHEQVEN;
   END IF;

   /*Atualiza as informaes da Movimentao de caixa*/
   UPDATE MOVCAIXA
      SET NRLANCTONF = NULL,
          CDFILIALNF = NULL
    WHERE CDFILIALNF = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   BEGIN
      SELECT CDEMPRESA, NRLANCTBDOC
        INTO V_CDEMPRESA, V_NRLANCTBDOC
        FROM NOTAFISCAL
       WHERE CDFILIAL = P_CDFILIAL
         AND NRLANCTONF = P_NRLANCTONF;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDEMPRESA := NULL; V_NRLANCTBDOC := NULL;
   END;

   DELETE FROM LANCCONT
    WHERE CDEMPRESA  = V_CDEMPRESA
      AND NRLANCCONT = V_NRLANCTBDOC;

   DELETE FROM NOTAFISCAL
    WHERE CDFILIAL   = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CANCELA_EXPORTA_PDV_FINANC','5.50.xxx'); END;
/

